<template>
    <transition>
        <b-card footer-bg-variant="transparent" :footer-border-variant="block ? 'danger' : 'light' " :footer="block ? ' ATTENTION : Cette réponse est insufisante pour la labélisation de votre école' : '' " :title="question"  :sub-title="'Catégorie : ' + categorie + ', Partie prenante : ' + partie" :class="'question mb-4 '+ catSlug">
            <template #header >
                <div v-bind:style="{background: gradient, padding: '0.75em', color: 'white'}">
                {{index}}
                </div>
            </template>
            <div class="options" v-if="inputType === 'radio'">
                <b-form-group class="option" v-for="(option,index) in options" :key="option.key">
                    <b-form-radio  :type="inputType" :value="option.value" v-model="localValue" :id="name+index" >{{option.label}}</b-form-radio>
                </b-form-group>
            </div>
            <div class="options" v-else>
                <b-form-group >
                    <b-form-checkbox-group v-for="(option,index) in options" :key="option.key">
                            <b-form-checkbox :type="inputType" :value="option.value" v-model="localValue" :id="name+index" >{{option.label}} </b-form-checkbox>
                    </b-form-checkbox-group>
                </b-form-group>
            </div>
        </b-card>
    </transition>
</template>

<script>
export default {
    name:"Question",
    data(){
        return {
            localValue: null,
            inputType: this.questionType == ('radio' || 'bool') ? 'radio' : 'checkbox'
        }
    },
    props:{
        question:{
            type:String,
            required:true
        },
        options:{
            type:Array,
            required:true,
            default(){
                return []
            }
        },
        value:{
            type:Number,
            required:true
        },
        name:{
            type:String,
            required:true
        },
        categorie:{
            type:String,
            required:true
        },
        partie:{
            type:String,
            required:true
        },
        questionType:{
            type:String,
            required:true
        },
        coef:{
            type:String,
            required: true
        },
        minima:{
            type:String,
            required: true
        },
        index:{
            type:String,
            required: true
        },
        block:{
            type:Boolean,
            required: false
        },
        catSlug:{
            type:String,
            required: true
        },
        catID:{
            type:Number,
            required:true
        },
        gradient:{
            type:String,
            required:true
        }
    },
    mounted(){
        if(this.value && this.questionType == 'radio') this.localValue = (this.value );
        if(this.value && this.questionType == 'checkbox') console.log(this.value);
    },
    watch:{
        localValue(){
            this.$emit("change",this.localValue);
            //this.$emit("change",this.localValue * this.coef);
        }
    }, 
    methods:{

    }
}
</script>

<style lang="css" scope>

    .card-header{
        border: none !important;
        padding: 0 !important;
    }
</style>
